unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CPort, CPortCtl, ExtCtrls, ComCtrls, inifiles, StrUtils,
  Menus, Grids, ToolWin, ImgList, ShellApi, Math;


const
  version_num='0.0.02 lite';
  version_date='2015.07.01';
  soft_name='BehaRFID';
  version='Version '+version_num+' ('+version_date+')';
  email='pmbogusz@gmail.com';
  webpage='http://www.pmbogusz.net/?a=rfidlite';

  AntMaxNum = 8;
  TagMaxNum = 100;

type
  TForm1 = class(TForm)
    ComPort1: TComPort;
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;
    ComPort2: TComPort;
    ComPort3: TComPort;
    ComPort4: TComPort;
    ComPort5: TComPort;
    ComPort6: TComPort;
    ComPort7: TComPort;
    ComPort8: TComPort;
    Timer1: TTimer;
    Shape1: TShape;
    lb_clock: TLabel;
    lb_c1: TLabel;
    lb_c2: TLabel;
    lb_c3: TLabel;
    lb_c4: TLabel;
    sg_rfid: TStringGrid;
    sg_tags: TStringGrid;
    lb_c5: TLabel;
    lb_c6: TLabel;
    lb_c7: TLabel;
    lb_c8: TLabel;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Port1: TMenuItem;
    est1: TMenuItem;
    Connect1: TMenuItem;
    ClearLog1: TMenuItem;
    Timer2: TTimer;
    Disconnect1: TMenuItem;
    sh_rec: TShape;
    Timer3: TTimer;
    bt_connect: TButton;
    N1: TMenuItem;
    LoadRFIDlist1: TMenuItem;
    SaveRFIDlist1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    OpenDialog1: TOpenDialog;
    lb_tagfilename: TLabel;
    Bevel1: TBevel;
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ReadIniFile;
    procedure SaveIniFile;
    procedure Timer1Timer(Sender: TObject);
    procedure ClearLog1Click(Sender: TObject);
    procedure Test1Click(Sender: TObject);
    procedure sg_rfidMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Connect1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer2Timer(Sender: TObject);
    procedure ReadTAGFile(f :string);
    procedure SaveTAGFile(f :string);

    procedure ResetTags;
    procedure ResetAnts;


    procedure DisconnectCOMS;
    procedure ConnectCOMS;
    procedure Disconnect1Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure bt_connectClick(Sender: TObject);
    procedure LoadRFIDlist1Click(Sender: TObject);
    procedure SaveRFIDlist1Click(Sender: TObject);
    procedure sg_tagsSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StatusBar1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



 Trfid   =  Record
    PortStatus        :Integer;                 
    PortCOM           :Integer;                 
    TagBits           :integer;                 
    TagData           :array[0..1023] of byte;  
    TagLast           :Int64;                   
    TagLastN          :integer;                 
    TagLastM          :integer;                 
    TagLastSTR        :String;                  

    TimeReadFirst     :TDateTime;               
    TimeReadFirstP    :Int64;                   
    TimeLastcall      :Int64;                   
    TimeLastcallFull  :Int64;                   

    TotalVisitsN      :Int64;                   
    TotalVisitsT      :Int64;                   

    TotalVisitsNrst   :Int64;                   
    TotalVisitsTrst   :Int64;                   
  end;


  TTag   =  Record
    Num               :Int64;                 
    NumN              :integer;               
    NumM              :integer;               
    NumSTR            :String;                
    Name              :String;                
    TotalVisitsN      :Int64;                 
    TotalVisitsT      :Int64;                 

    TotalVisitsNrst      :Int64;              
    TotalVisitsTrst      :Int64;

    VisitsN           :Array[1..AntMaxNum] of Int64;    
    VisitsT           :Array[1..AntMaxNum] of Int64;
  end;


var
  Form1: TForm1;

  FreqTimer,
  StartTimer,
  StopTimer,

  DurationStart,
  DurationStop,
  Duration,

  MaxDelay,

  LastCallFromPort,
  TotalCalls           :Int64;

  rfid              :array[1..AntMaxNum] of Trfid;
  Tags              :array[1..TagMaxNum] of TTag;
  TagsNum           :integer;

  SaveLog           :boolean;
  MainLog           :TStringList;
  LogFilename       :string;
  RfidTagsList      :string;

  connected         :boolean;


implementation


{$R *.dfm}

Function IntToStrZero(N:Integer;Z:integer):string;
var
  s:string;
begin
  s:='000000000000000000000000000000'+IntToStr(N);
  IntToStrZero:=Copy(s,Length(s)-Z+1,99999);
end;

Function TimeToStrLong(N:Real):string;
var
  h,m,s,ms      :string;
  ts            :integer;
begin
  ts:=Floor(N);
  h :=IntToStrZero(ts div (60*60),2);
  m :=IntToStrZero((ts mod (60*60)) div (60),2);
  s :=IntToStrZero(ts mod (60),2);
  ms:=IntToStrZero((Round(N*100) mod 60000) ,2);
  TimeToStrLong:=h+':'+m+':'+s+'.'+ms;
end;




procedure TForm1.ReadIniFile;
var
  IFile : TIniFile;
  x     :integer;
begin
  IFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  try
    For x:=1 to AntMaxNum do begin
      try
        (Findcomponent('ComPort'+IntToStr(x)) as TComPort).Port                     := iFile.ReadString('RS323','Port'+IntToStr(x),'COM'+IntToStr(x));
        (Findcomponent('ComPort'+IntToStr(x)) as TComPort).BaudRate                 := StrToBaudRate(iFile.ReadString('RS323','BaudRate','57600'));
        (Findcomponent('ComPort'+IntToStr(x)) as TComPort).DataBits                 := StrToDataBits(iFile.ReadString('RS323','DataBits','8'));
        (Findcomponent('ComPort'+IntToStr(x)) as TComPort).StopBits                 := StrToStopBits(iFile.ReadString('RS323','StopBits','1'));
        (Findcomponent('ComPort'+IntToStr(x)) as TComPort).Parity.Bits              := StrToParity(iFile.ReadString('RS323','Parity','None'));
        (Findcomponent('ComPort'+IntToStr(x)) as TComPort).FlowControl.FlowControl  := StrToFlowControl(iFile.ReadString('Left Port','FlowControl','None'));
      Except
      end;
    end;

    RfidTagsList   :=   iFile.ReadString('config','rfid_tags_list','rfid_tags.txt');
    MaxDelay       :=   iFile.ReadInteger('config','rfid_max_delay',210);


  finally
    IFile.Free;
  end;
end;


procedure TForm1.SaveIniFile;
var
  IFile : TIniFile;
  x     :integer;
begin
  IFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  try
    iFile.WriteString('RS323','BaudRate',BaudRateToStr(ComPort1.BaudRate));
    iFile.WriteString('RS323','DataBits',DataBitsToStr(ComPort1.DataBits));
    iFile.WriteString('RS323','StopBits',StopBitsToStr(ComPort1.StopBits));
    iFile.WriteString('RS323','Parity',ParityToStr(ComPort1.Parity.Bits));
    iFile.WriteString('RS323','FlowControl',FlowControlToStr(ComPort1.FlowControl.FlowControl));
    For x:=1 to AntMaxNum do begin
      try
        iFile.WriteString('RS323','Port'+IntToStr(x),(Findcomponent('ComPort'+IntToStr(x)) as TComPort).Port);
      Except
      end;
    end;

    iFile.WriteString('config','rfid_tags_list',ExtractFileName(RfidTagsList));
    iFile.WriteInteger('config','rfid_max_delay',MaxDelay);

  finally
    IFile.Free;
  end;
end;

procedure TForm1.ResetTags;
var
  x,y        :integer;

begin
    for x:=1 to TagMaxNum do begin
        Tags[x].Num:=0;
        Tags[x].NumN:=0;
        Tags[x].NumM:=0;
        Tags[x].NumSTR:='';
        Tags[x].Name:='';
        Tags[x].TotalVisitsN:=0;
        Tags[x].TotalVisitsT:=0;
        Tags[x].TotalVisitsNrst:=0;
        Tags[x].TotalVisitsTrst:=0;
        for y:=1 to AntMaxNum do begin
            Tags[x].VisitsN[y]:=0;
            Tags[x].VisitsT[y]:=0;
        end;
    end;
    TagsNum := 0;
end;


procedure TForm1.ResetAnts;
var
   x        :integer;
begin
    for x:=1 to AntMaxNum do begin
        rfid[x].PortStatus:=0;
        rfid[x].PortCOM:=0;
        rfid[x].TagBits:=0;
        rfid[x].TagLast:=0;
        rfid[x].TagLastN:=0;
        rfid[x].TagLastM:=0;
        rfid[x].TagLastSTR:='';
        rfid[x].TimeReadFirst:=0;
        rfid[x].TimeReadFirstP:=0;
        rfid[x].TimeLastcall:=0;
        rfid[x].TimeLastcallFull:=0;
        rfid[x].TotalVisitsN:=0;
        rfid[x].TotalVisitsT:=0;
        rfid[x].TotalVisitsNrst:=0;
        rfid[x].TotalVisitsTrst:=0;
    end;
end;



procedure TForm1.ReadTAGFile(f :string);
var
    m          :TStrings;
    x,y        :integer;
    num        :int64;
  
begin
    ResetTags;

    For x:= 1 to sg_tags.RowCount-1 do begin
        For y:= 0 to sg_tags.ColCount-1 do begin
            sg_tags.Cells[y,x]   := '';
        end;
    end;

    m := TStringList.Create;
    m.LoadFromFile(f);

    For x:= 0 to m.Count-1 do m[x]:=trim(m[x]);

    x:=0;
    While x <= m.Count-1  do begin
          if (m[x]='') OR (m[x][1]=';') OR (m[x][1]='/')  OR (Pos('=',m[x])=0)
             then m.Delete(x)
             else inc(x);
    end;

    For x:= 1 to m.Count do begin
        Tags[x].NumSTR       :=  trim(copy(m[x-1],1,Pos('=',m[x-1])-1));
        Tags[x].Name         :=  trim(copy(m[x-1],Pos('=',m[x-1])+1,9999999));
        Tags[x].NumN         := StrToInt(RightStr(Tags[x].NumSTR, 10));
        Tags[x].NumM         := StrToInt(LeftStr(Tags[x].NumSTR, 4));
        num                  := Tags[x].NumM;
        num                  := num * 16   * 256  * 256 * 256;
        Tags[x].Num          := num + Tags[x].NumN;
        sg_tags.Cells[0,x]   := Tags[x].NumSTR;
        sg_tags.Cells[1,x]   := Tags[x].Name;
    end;
    TagsNum:=m.Count;
    m.Destroy;
    lb_tagfilename.Caption:=  'TAGS File in use: '+RfidTagsList;

end;




procedure TForm1.SaveTAGFile(f :string);
var
    m          :TStrings;
    x          :integer;
begin
    m := TStringList.Create;
    For x:= 1 to TagsNum do begin
        if (trim(Tags[x].NumSTR)<>'') then m.Add(trim(Tags[x].NumSTR)+'='+trim(Tags[x].Name));
    end;
    m.SaveToFile(f);
    m.Destroy;
end;



procedure TForm1.ComPortRxChar(Sender: TObject; Count: Integer);
var

  pn          :integer;
  NowTime     :TDateTime;
  NowCounter  :int64;
  TagN        :int64;

begin
  QueryPerformanceCounter(NowCounter);
  NowTime := now();
  pn := StrToInt(RightStr((sender as TComPort).Name,1));
  LastCallFromPort:=NowCounter;
  with rfid[pn] do begin

    if Count = 9 then begin
      (sender as TComPort).Read(TagData[0],count);
      TagBits := 9;
    end
    else begin
      (sender as TComPort).Read(TagData[TagBits],count);
      inc(TagBits,count);
    end;

    if TagBits = 9 then begin

      TagN := (TagData[3]*256*256);
      TagN := TagN * 256*256 ;
      TagN:=  TagN + (TagData[4]*256*256*256) + (TagData[5]*256*256) + (TagData[6]*256) + TagData[7] ;

      if TagN <> TagLast then begin
        TimeReadFirst  := NowTime;
        TimeReadFirstP := NowCounter;
        TagLast:= TagN;
        TagLastN    := ((TagData[4] and  $0F)*256*256*256) + (TagData[5]*256*256) + (TagData[6]*256) + TagData[7] ;
        TagLastM    := (TagData[3] shl 4) + (TagData[4] shr 4);
        TagLastStr  := RightStr('0000'+IntToStr(TagLastM),4)+ '-'+RightStr('0000000000'+IntToStr(TagLastN),10);

        With (Findcomponent('lb_c'+IntToStr(pn)) as TLabel) do begin
          caption :=TagLastStr;
          color := clLime;
        end;
      end;

      TagBits := 0;
      TimeLastcall := NowCounter;
    end;
  end; {with}
end;




procedure TForm1.Timer1Timer(Sender: TObject);
var
    x,y,z,v         :integer;
    T1, T2, T3      :int64;
    diff            :longInt;
    D1, D2          :TDateTime;
    newtag          :boolean;
    s, m            :string;
begin
    D1 := now();
    lb_clock.Caption:= FormatDateTime('hh:nn:ss', D1);
    QueryPerformanceCounter(T1);

    for  x:=1 to AntMaxNum do begin
        if (rfid[x].PortStatus = 1) AND (rfid[x].TagLast > 0) then begin
            diff:= Round((T1 - rfid[x].TimeLastcall)* 1000 / FreqTimer);
            if (diff > MaxDelay) then begin
                // wylczamy kontrolk
                With (Findcomponent('lb_c'+IntToStr(x)) as TLabel) do begin
                    caption :='';
                    color := clGreen;
                end;

                T2:= Round((T1 - rfid[x].TimeReadFirstP)* 1000 / FreqTimer);
                Inc(TotalCalls);

                // Gowny zapis do logu

                m := '';
                m := m + IntToStr(TotalCalls);
                m := m + Char(9) + FormatDateTime('yyyy.mm.dd',   rfid[x].TimeReadFirst);
                m := m + Char(9) + FormatDateTime('hh:nn:ss.zzz', rfid[x].TimeReadFirst);
                m := m + Char(9) + IntToStr(x);
                m := m + Char(9) + IntToStr(T2);
                m := m + Char(9) + rfid[x].TagLastStr;

                for v:=1 to TagsNum do begin
                    if Tags[v].NumSTR=rfid[x].TagLastStr then m := m + Char(9) + Tags[v].Name;
                end;

                MainLog.add(m);

                SaveLog := true;

                if (Memo1.lines.Count > 50) then Memo1.lines.Delete(0);
                Memo1.lines.add(FormatDateTime('hh:nn:ss', rfid[x].TimeReadFirst)+' '+RightStr('   '+IntToStr(x),3)+' '+RightStr('     '+IntToStr(T2),5)+'  '+rfid[x].TagLastStr);


                Inc(rfid[x].TotalVisitsN);
                Inc(rfid[x].TotalVisitsNrst);

                rfid[x].TotalVisitsT:=rfid[x].TotalVisitsT + T2;
                rfid[x].TotalVisitsT:=rfid[x].TotalVisitsTrst + T2;

                sg_rfid.Cells[1,x]:= IntToStr(rfid[x].TotalVisitsN);
                sg_rfid.Cells[2,x]:= TimeToStrLong(rfid[x].TotalVisitsT / 1000);

                newtag:=true;

                for y:=1 to TagsNum do begin
                    if (Tags[y].Num = rfid[x].TagLast) then begin
                       newtag:=false;
                       Inc(Tags[y].TotalVisitsN);
                       Inc(Tags[y].TotalVisitsT,T2);
                       Inc(Tags[y].TotalVisitsNrst);
                       Inc(Tags[y].TotalVisitsTrst,T2);

                       sg_tags.Cells[2,y]:=IntToStr(Tags[y].TotalVisitsN);
                       sg_tags.Cells[3,y]:=TimeToStrLong(Tags[y].TotalVisitsT / 1000);
                    end;
                end;

                if NewTag then begin
                   NewTag:=false;
                   inc(TagsNum);
                   Tags[TagsNum].Num    := rfid[x].TagLast;
                   Tags[TagsNum].NumN   := rfid[x].TagLastN;
                   Tags[TagsNum].NumM   := rfid[x].TagLastM;
                   Tags[TagsNum].NumSTR := rfid[x].TagLastStr;

                   Tags[TagsNum].TotalVisitsN := 1;
                   Tags[TagsNum].TotalVisitsT := T2;

                   Tags[TagsNum].TotalVisitsNrst := 1;
                   Tags[TagsNum].TotalVisitsTrst := T2;

                   sg_tags.Cells[0,TagsNum] := Tags[y].NumSTR;
                   sg_tags.Cells[2,TagsNum] := IntToStr(Tags[y].TotalVisitsN);
                   sg_tags.Cells[3,TagsNum] := TimeToStrLong(Tags[y].TotalVisitsT / 1000);
                end;

                rfid[x].TimeReadFirst  := 0;
                rfid[x].TimeReadFirstP := 0;
                rfid[x].TagLast:=0;
                rfid[x].TagLastStr:='';
            end;
        end;
    end;
end;




procedure TForm1.FormCreate(Sender: TObject);
var
  LogFilenameNew,
  LogFilenameRename      :string;
  x                      :integer;
begin


  Form1.Caption:=soft_name+' '+version_num;
  StatusBar1.SimplePanel:=true;
  StatusBar1.SimpleText:=soft_name+' '+version+' Pawe Boguszewski '+webpage;

  Randomize;

  connected :=False;

  MainLog := TstringList.create;
  SaveLog := false;
  TotalCalls :=0;
  LogFilename :='';

  QueryPerformanceFrequency(FreqTimer);
  QueryPerformanceCounter(StartTimer);

  ReadIniFile;

  LogFilenameNew:=FormatDateTime('yyyymmdd_hh', now())+'0000.txt';

  if FileExists(LogFilenameNew) then begin
    x:=1;
    Repeat
      LogFilenameRename := FormatDateTime('yyyymmdd_hh', now())+'0000_'+IntToStrZero(x,3)+'.txt';
      inc(x);
    Until NOT FileExists(LogFilenameRename);
    RenameFile(LogFilenameNew, LogFilenameRename);
  end;

  if FileExists(RfidTagsList) then ReadTAGFile(RfidTagsList);
end;




procedure TForm1.FormDestroy(Sender: TObject);
begin
  SaveTAGFile(RfidTagsList);
  SaveIniFile;
end;

procedure TForm1.ClearLog1Click(Sender: TObject);
begin
  Memo1.Clear;
  TotalCalls :=0;
end;




procedure TForm1.Test1Click(Sender: TObject);
var
    x          :integer;
    comerror   :boolean;
    com_old    :string;
begin
  com_old := comport1.Port;
  for x:=1 to 256 do begin
    try
      comerror:=false;
      comport1.Port:='COM'+IntToStr(x);
      comport1.Open;
      comport1.WriteStr('0');
    Except
      comerror:=true;
    end;
    if NOT comerror then begin
      Form1.Memo1.lines.add('COM'+IntToStr(x)+' OK');
      comport1.Close;
    end;
  end;
  comport1.Port := com_old;
end;






procedure TForm1.sg_rfidMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ARow,Acol               :integer;
begin
   ARow:= sg_rfid.selection.top;
   Acol:= sg_rfid.selection.left;
   If ACol=0 then (Findcomponent('ComPort'+IntToStr(ARow)) as TComPort).ShowSetupDialog;
end;


procedure TForm1.ConnectCOMS;
var
  x     :integer;
begin
  Timer2.Enabled:=true;
  connected:=true;

  For x:=1 to AntMaxNum do begin
    With (Findcomponent('ComPort'+IntToStr(x)) as TComPort) do begin
      rfid[x].PortStatus:=0;
      rfid[x].PortCOM:=0;
      if port <> 'COM0' then begin
        rfid[x].PortCOM:= StrToInt(Copy(Port,4,99));
        try
          Close;
          Open;
          Form1.Memo1.lines.add('ComPort'+IntToStr(x)+' Port = '+Port);
          rfid[x].PortStatus:=1;
        Except
          rfid[x].PortStatus:=3;
        end;
      end
      else begin
        rfid[x].PortStatus:=2;
      end;
    end;
  end;

  For x:=1 to AntMaxNum do begin
    With (Findcomponent('lb_c'+IntToStr(x)) as TLabel) do begin
      if rfid[x].PortStatus = 0 then begin
        font.Color:=clWhite;
        caption := IntToStr(rfid[x].PortCOM)+' ???';
        color   := clRed;
        sg_rfid.Cells[0,x] := IntToStr(rfid[x].PortCOM);
      end;
      if rfid[x].PortStatus = 1 then begin
        font.Color:=clBlack;
        caption := '';
        color   := clGreen;
        sg_rfid.Cells[0,x] := 'COM'+IntToStr(rfid[x].PortCOM);
      end;
      if rfid[x].PortStatus = 2 then begin
        font.Color:=clWhite;
        caption := 'COM'+IntToStr(rfid[x].PortCOM)+' OFF';
        color   := clGray;
        sg_rfid.Cells[0,x] := '-';
      end;
      if rfid[x].PortStatus = 3 then begin
        font.Color:=clWhite;
        caption := 'COM'+IntToStr(rfid[x].PortCOM)+' Error';
        color   := clMaroon;
        sg_rfid.Cells[0,x] := 'error';
      end;
    end;
  end;
end;





procedure TForm1.DisconnectCOMS;
var
  x     :integer;
begin
  Timer2.Enabled:=false;
  connected:=False;


  For x:=1 to AntMaxNum do begin
    With (Findcomponent('ComPort'+IntToStr(x)) as TComPort) do begin
      If rfid[x].PortStatus=1 then begin;
        try
          Close;
          rfid[x].PortStatus:=0;
        Except
          rfid[x].PortStatus:=1;
        end;
      end
    end;
  end;
end;


procedure TForm1.Timer2Timer(Sender: TObject);
var
  LogFilenameNew      :string;
  x                   :integer;
begin
  if SaveLog then begin
    LogFilenameNew:=FormatDateTime('yyyymmdd_hh', now())+'0000.txt';
    if (LogFilename = '') then LogFilename:=LogFilenameNew;

    MainLog.SaveToFile(LogFilename);

    if LogFilenameNew <> LogFilename then begin
       MainLog.Clear;
       LogFilename:=LogFilenameNew;
    end;
    SaveLog := false;
  end;
end;




procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DisconnectCOMS;
  MainLog.Free;
  connected:=False;
end;


procedure TForm1.Connect1Click(Sender: TObject);
begin
  ConnectCOMS;
  bt_connect.Caption:='DISCONNECT';
end;


procedure TForm1.Disconnect1Click(Sender: TObject);
begin
  Timer2Timer(Sender);
  DisconnectCOMS;
  bt_connect.Caption:='CONNECT';
end;


procedure TForm1.Timer3Timer(Sender: TObject);
begin
  If connected then begin
    if  sh_rec.Brush.Color=clRed then sh_rec.Brush.Color:=clMaroon else  sh_rec.Brush.Color:=clRed ;
  end
  else sh_rec.Brush.Color:=clGray;
end;





procedure TForm1.bt_connectClick(Sender: TObject);
begin
  If connected then begin
    DisconnectCOMS;
    bt_connect.Caption:='CONNECT';
  end
  else begin
    ConnectCOMS;
    bt_connect.Caption:='DISCONNECT';
  end;
end;

procedure TForm1.LoadRFIDlist1Click(Sender: TObject);
begin

  if OpenDialog1.Execute then begin
    if FileExists(OpenDialog1.FileName) then begin
      RfidTagsList :=  OpenDialog1.FileName;
      ReadTAGFile(RfidTagsList);
      SaveIniFile;
    end;
  end;
end;

procedure TForm1.SaveRFIDlist1Click(Sender: TObject);
begin
  SaveDialog1.FileName:= RfidTagsList;
  if SaveDialog1.Execute then begin
      RfidTagsList :=  ExtractFileName(SaveDialog1.FileName);
      SaveTAGFile(RfidTagsList);
      SaveIniFile;
  end;
end;


procedure TForm1.sg_tagsSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
    Tags[ARow].Name := sg_tags.Cells[1,ARow];
    SaveTAGFile(RfidTagsList);

end;

procedure TForm1.StatusBar1Click(Sender: TObject);
begin
ShellExecute(0, 'open', PChar(webpage), nil, nil, SW_SHOWNORMAL);

end;

end.
